<script>

	import { onMount } from 'svelte';

	export let status = [];

	function onMessage(data) {

		switch(data.action) {

			case 'set_status' : {
				status = data.status;
				break;
			}

			default: break;
		}

	}

	onMount(() => {
		window.parent.postMessage(JSON.stringify({action: 'component_mounted'}), '*');
	});

	window.addEventListener('message', e => {
		try {
			onMessage(JSON.parse(e.data));
		} catch(e) {}
	});

</script>

<style>

	.status-wrap {
		width : 100%;
		height: 100%;
	}

	.status {
		width : calc(200px - 32px);
    display: flex;
    flex-direction: row;
		justify-content: space-between;
		margin-bottom: 8px;
	}

	.status-icon {
		padding-right: 8px;
	}

	.status-bar-wrap {
		width: 100%;
		display: flex;
		flex-direction: column;
		align-items: flex-start;
		justify-content: center;
	}

	.status-bar {
		width: 100%;
		height: 8px;
	}

</style>

<div class="status-wrap">
	{#each status as _status}
		<div class="status">
			<div class="status-icon"><span class="fas fa-{_status.icon}" style="color: {_status.color};"></span></div>
			<div class="status-bar-wrap">
				<div class="status-bar" style="width: {_status.val * 100}%; background-color: {_status.color};"></div>
			</div>
		</div>
	{/each}
</div>
